//******************************
// Librairies
//******************************

#include <avr/interrupt.h>

//******************************
// Variables globales
//******************************

unsigned char Usart_recuchar;
unsigned char Usart_recuvalid;

//******************************
// Fonctions
//******************************

// Envoi de donnes sur l'Usart (liaison srie)
void Usart_putc(unsigned char c) {
	if (c == '\n')
		Usart_putc('\r');
	// wait until UDR ready
	while(!(UCSRA & (1 << UDRE)));
	// send character
	UDR = c;
}
void Usart_puts (char *s) {
	//  loop until *s != NULL
	while (*s) {
		Usart_putc(*s);
		s++;
	}
}
void Usart_putint(unsigned int c) {

	// On doit sans aucun doute pouvoir optimiser a un peu...

	if (c >= 30000) { Usart_putc('3'); c -= 30000; }
	else if (c >= 20000) { Usart_putc('2'); c -= 20000; }
	else if (c >= 10000) { Usart_putc('1'); c -= 10000; }
	else Usart_putc('0');

	if (c >= 9000) { Usart_putc('9'); c -= 9000; }
	else if (c >= 8000) { Usart_putc('8'); c -= 8000; }
	else if (c >= 7000) { Usart_putc('7'); c -= 7000; }
	else if (c >= 6000) { Usart_putc('6'); c -= 6000; }
	else if (c >= 5000) { Usart_putc('5'); c -= 5000; }
	else if (c >= 4000) { Usart_putc('4'); c -= 4000; }
	else if (c >= 3000) { Usart_putc('3'); c -= 3000; }
	else if (c >= 2000) { Usart_putc('2'); c -= 2000; }
	else if (c >= 1000) { Usart_putc('1'); c -= 1000; }
	else Usart_putc('0');

	if (c >= 900) { Usart_putc('9'); c -= 900; }
	else if (c >= 800) { Usart_putc('8'); c -= 800; }
	else if (c >= 700) { Usart_putc('7'); c -= 700; }
	else if (c >= 600) { Usart_putc('6'); c -= 600; }
	else if (c >= 500) { Usart_putc('5'); c -= 500; }
	else if (c >= 400) { Usart_putc('4'); c -= 400; }
	else if (c >= 300) { Usart_putc('3'); c -= 300; }
	else if (c >= 200) { Usart_putc('2'); c -= 200; }
	else if (c >= 100) { Usart_putc('1'); c -= 100; }
	else Usart_putc('0');

	if (c >= 90) { Usart_putc('9'); c -= 90; }
	else if (c >= 80) { Usart_putc('8'); c -= 80; }
	else if (c >= 70) { Usart_putc('7'); c -= 70; }
	else if (c >= 60) { Usart_putc('6'); c -= 60; }
	else if (c >= 50) { Usart_putc('5'); c -= 50; }
	else if (c >= 40) { Usart_putc('4'); c -= 40; }
	else if (c >= 30) { Usart_putc('3'); c -= 30; }
	else if (c >= 20) { Usart_putc('2'); c -= 20; }
	else if (c >= 10) { Usart_putc('1'); c -= 10; }
	else Usart_putc('0');

	if (c == 9) Usart_putc('9');
	else if (c == 8) Usart_putc('8');
	else if (c == 7) Usart_putc('7');
	else if (c == 6) Usart_putc('6');
	else if (c == 5) Usart_putc('5');
	else if (c == 4) Usart_putc('4');
	else if (c == 3) Usart_putc('3');
	else if (c == 2) Usart_putc('2');
	else if (c == 1) Usart_putc('1');
	else Usart_putc('0');

	Usart_putc('\t');
}
void Usart_putsint(signed int c) {
	if (c >= 0) {
		Usart_putint((unsigned int)(c));
	} else {
		Usart_putc('-');
		Usart_putint((unsigned int)(-c));
	}
}
unsigned char Usart_getc(void) {

/*	while (!Usart_recuvalid);
	Usart_recuvalid = 0;
	return Usart_recuchar;*/

	while (!(UCSRA & (1<<RXC)));
	Usart_recuchar = UDR;

	if (!(UCSRA & (1<<FE)) && !(UCSRA & (1<<PE))) // S'il n'y a pas d'erreur de parit
		Usart_recuvalid = 1;

	return Usart_recuchar;

}

//******************************
// Interruptions
//******************************

/*ISR(USART_RXC_vect)  { // USART RX interrupt

	Usart_recuchar = UDR;
	if (!(UCSRA & (1<<FE)) && !(UCSRA & (1<<PE))) // S'il n'y a pas d'erreur de parit
		Usart_recuvalid = 1;

}*/


//******************************
// Fonctions de configuration
//******************************

void Usart_Init() {

	// Wait latest receive character was pull from UDR
	while (UCSRA & (1<<RXC));

	// Wait end of transmission
	while (!(UCSRA & (1<<UDRE)));

	// Disable transmitter and receiver
	UCSRB &= ~((1<<RXEN) | (1<<TXEN));

	// UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) = ((F_OSC)/((UART_BAUD_RATE)*16l)-1)
	UBRRH = 0;
	//UBRRL = 103; // 9600bauds
	//UBRRL = 51;  // 19200bauds
	//UBRRL = 25;  // 38400bauds
	UBRRL = 8;     // 115200bauds


	// Async mode, no parity, 1 stop bit, 8 data bits, UCPOL set to zero for async transfert mode */
	UCSRC = 0b10000110;

	// Enable transmitter and receiver (RXEN and TXEN), enable reception interrupt (RXCIE) */
	UCSRB = /*(1<<RXCIE) |*/ (1<<RXEN) | (1<<TXEN);

}
