/*
// Gre un bargraph pilot par un 4040 sur 10bits

//Requis :
#define BARG_RST_DDR
#define BARG_RST_PORT
#define BARG_RST_PIN
#define BARG_CNT_DDR
#define BARG_CNT_PORT
#define BARG_CNT_PIN
*/

#if !defined(__LIB_BARGRAPH__)

	#define __LIB_BARGRAPH__

//******************************
// Librairies
//******************************

#include "delais.c"
#include "bitmanip.c"

//******************************
// Variables globales
//******************************

unsigned int Bargraph_oldvalue = 0;

//******************************
// Fonctions
//******************************

void BarGraph_Init() {

	// Configuration en sortie des ports
	sbi(BARG_RST_DDR,  BARG_RST_PIN);
	sbi(BARG_CNT_DDR,  BARG_CNT_PIN);
	cbi(BARG_RST_PORT, BARG_RST_PIN);
	cbi(BARG_CNT_PORT, BARG_CNT_PIN);

	// Premire remise  0
	sbi(BARG_RST_PORT, BARG_RST_PIN);
	_delay_us(1);
	cbi(BARG_RST_PORT, BARG_RST_PIN);

	Bargraph_oldvalue = 0;
}
void BarGraph_SetValue(unsigned int value) {

	// On plafonne  2^10 valeurs
	if (value > 0b1111111111)
		value = 0b1111111111;

	// Pas la peine de changer si on demande la mme chose
	if (value == Bargraph_oldvalue)
		return;

	if (value < Bargraph_oldvalue) {
		// Remise  0
		sbi(BARG_RST_PORT, BARG_RST_PIN);
		_delay_us(1);
		cbi(BARG_RST_PORT, BARG_RST_PIN);
		Bargraph_oldvalue = value;
	} else {
		// On ne rajoute que la diffrence
		value -= Bargraph_oldvalue;
		Bargraph_oldvalue += value;
	}

	for (; value > 0; value--) {
		sbi(BARG_CNT_PORT, BARG_CNT_PIN);
		_delay_us(1);
		cbi(BARG_CNT_PORT, BARG_CNT_PIN);
		_delay_us(1);
	}
}

#endif
